library ieee;
use ieee.std_logic_1164.all;		-- std_logic_vector
use ieee.std_logic_arith.all;		-- conv_std_logic
use ieee.std_logic_unsigned.all;	-- ditto

entity accu is
	generic(	NDI : integer := 16;
			NDO : integer := 21
		);
	port(	accu_in : in std_logic_vector( (NDI - 1) downto 0);
		accu_ctrl : in bit;
		clk : in bit;
		reset : in bit;
		accu_out : out std_logic_vector( (NDO - 1) downto 0));
end entity;

architecture beh of accu is
	signal buf : integer;
begin
	p : process( clk, reset, accu_ctrl, accu_in)
	begin
		if (reset = '1') then
			buf <= 0;
		elsif (clk'event and clk = '1') then
--		if (clk'event and clk = '1') then
--		if (clk'event) then
			if (accu_ctrl = '1') then
				buf <= buf + conv_integer( accu_in);
			else
				buf <= 0;
			end if;
		end if;
	end process;
	accu_out <= conv_std_logic_vector( buf, NDO);
end architecture;


