library ieee;
use ieee.std_logic_1164.all;		-- std_logic_vector
use ieee.std_logic_arith.all;		-- conv_std_logic
use ieee.std_logic_unsigned.all;	-- ditto
library std;
use std.textio.all;			-- to read/write files

entity buff is
	generic(	ND : integer := 8;	-- data width
			USE_FILE : integer := 1;	-- 1 to use an output file
			BUF_FILE : string := "buff.txt";	-- file containing buff samples
			VERBOSE : integer := 1
		);

	port(	buff_in : in std_logic_vector( (ND - 1) downto 0);
		buff_oe : in bit;
		clk : in bit;
		reset : in bit;
		buff_out : out std_logic_vector( (ND - 1) downto 0));
end entity;

architecture beh of buff is
	signal count:integer:=1;
begin
	p : process( clk, reset, buff_oe, buff_in)
		file buf_file : text open write_mode is BUF_FILE;
		variable s : line;
	begin
		if (reset = '1' and reset'event) then
			buff_out <= (others => '0');
		else
--		if (clk'event and buff_oe = '1') then
--		if (clk'event and clk = '1' and buff_oe = '1') then
		if (buff_oe'event and buff_oe = '1') then
			buff_out <= buff_in;
			if (USE_FILE = 1) then
				write( s, conv_integer( buff_out));
				writeline( buf_file, s);
			end if;
			if (VERBOSE = 1) then
				write( s, "Output sample #");
				write( s, count);
				write( s, " value=");
				write( s, conv_integer( buff_out));
				write( s, " at ");
				write( s, now);
				writeline( output, s);
			end if;
			count <= count+1;
		end if;
		end if;
	end process;
end architecture;



