library ieee;
use ieee.std_logic_1164.all;		-- std_logic_vector
use ieee.std_logic_arith.all;		-- conv_std_logic
use ieee.std_logic_unsigned.all;	-- ditto

entity fsm is
	generic(	NA : integer := 2);
	
	port(	clk, reset, adc_busy : in bit;
		adc_convstb, adc_rd_csb : out bit;
		rom_address : out std_logic_vector( (NA-1) downto 0);
		delay_line_address : out std_logic_vector( (NA-1) downto 0);
		delay_line_sample_shift, accu_ctrl, buff_oe : out bit
	);
end entity;

-- second trial beh : samples+calc*32 every 1 us + being synthesisability (ie : no 'wait for', 'after', etc..)

--architecture beh of fsm is
--	constant DELTAMIN : time := 50 ns;		-- min pulse time is 30 ns for convstb and rdb
----	constant DELTAMIN : time := 3 ns;		-- min pulse time is 30 ns for convstb and rdb
--
--	constant DELTABIG : time := 40 ns;		-- bigger pulse time
--	constant PADT : time := 150 ns;			-- padding time to fit 1 us
--
--	type fir_fsm is ( s0, s00, s1, s2, s3);
--	signal state : fir_fsm;
--	signal count_calc : integer;
--	signal rom_addr, delay_addr : integer;
--
--	signal dur_convstb : integer := 0;
--	signal sched_convstb : integer := -1;
--	signal dur_rdb : integer := 0;
--	signal sched_rdb : integer := -1;
--	
--	signal jiffies : integer := 0;
--	signal previous : integer;
--
--begin
--	Zstate <= 	0 when (state = s0) else
--			1 when (state = s1) else
--			2 when (state = s2) else
--			3 when (state = s3);
--	rom_address <= conv_std_logic_vector( rom_addr, NA);
--	delay_line_address <= conv_std_logic_vector( delay_addr, NA);
--	
--	Zcount_calc <= count_calc;
--
--	p : process( reset, clk, adc_busy)
--	begin
--		if (reset = '1') then						-- init everything on reset
--			jiffies <= 0;
--			adc_convstb <= '1';
--			adc_rd_csb <= '1';
--
--			sched_convstb <= -1;
--			dur_convstb <= 0;
--			sched_rdb <= -1;
--			dur_rdb <= 0;
--
--			buff_oe <= '0';
--			rom_addr <= 0;
--			delay_addr <= 0;
--			accu_ctrl <= '0';
--			delay_line_sample_shift <= '0';
--			count_calc <= 0;
--
--			state <= s0;
--		else
--			case state is
--				when s0 =>
--					if (adc_busy'event and adc_busy = '1') then
--						sched_convstb <= jiffies;
--						dur_convstb <= 1;
----						adc_convstb <= '0' after 0 ns, '1' after DELTAMIN;	-- start first conversion now
--					elsif (adc_busy'event and adc_busy = '0') then
--						state <= s1;			-- conv inited, JUMP TO S1
--					end if;
--				
--				when s00 =>
--					
--				when s1 =>
--				--	if (adc_busy'event and adc_busy = '1') then	-- wait for initiated conversion to finish..
--						rom_addr <= 0;
--						delay_addr <= 0;
--						count_calc <= 0;			-- count is the number of loops (ie : samples/coeffs) to calculate next
----						adc_rd_csb <= '0' after 0 ns, '1' after DELTAMIN;	-- time to read the result..
--						delay_line_sample_shift <= '1' after 0 ns, '0' after DELTAMIN;	-- latch up
--						accu_ctrl <= '1';		-- .. and do maths on it
--
----						adc_convstb <= '0' after 2*DELTABIG, '1' after 3*DELTABIG;		-- stop asking then
----						adc_convstb <= '0' after 0 ns, '1' after 25 ns;		-- stop asking then (pulse is 20 ns min)
--						sched_convstb <= jiffies + 4 + 11;	-- because conv must go 30ns min after rdb goes up
--						dur_convstb <= 1;
--						sched_rdb <= jiffies;
--						dur_rdb <= 2;
--						
--						accu_ctrl <= '1';		-- .. and do maths on it
--
--						state <= s2;			-- JUMP TO S2
--			--		end if;
--				when s2 =>
--					if (clk'event) then
--						if (count_calc >= (2**NA-1)) then
--							buff_oe <= '1' after 0 ns, '0' after DELTABIG;	-- calculus is over : hand over the result
--							state <= s3;			-- JUMP TO S3
--							count_calc <= 0;
--							accu_ctrl <= '0';
--						else
--							count_calc <= count_calc + 1;		-- calc loop
--							rom_addr <= rom_addr + 1;	-- do the maths..
--							delay_addr <= delay_addr + 1;	--
--						end if;
--					end if;
--				when s3 =>
----					state <= s1 after PADT;
--					state <= s1;			-- FIXE : we should pad-wait to reach 1us per sample
--			end case;
--			if (clk'event) then
--				jiffies <= jiffies + 1;
--			end if;
--
--			if (jiffies'last_value = (sched_convstb + dur_convstb)) then
--				adc_convstb <= '1';
--			elsif (jiffies'last_value = sched_convstb) then
--				adc_convstb <= '0';
--			end if;
--			if (jiffies'last_value = (sched_rdb + dur_rdb)) then
--				adc_rd_csb <= '1';
--			elsif (jiffies'last_value = sched_rdb) then
--				adc_rd_csb <= '0';
--			end if;
--			
--		end if;
--	end process;
--end architecture;

-- trial beh : samples+calc*32 every 1 us + being synthesisability (ie : no 'wait for', 'after', etc..)

--architecture beh of fsm is
--	constant DELTAMIN : time := 50 ns;		-- min pulse time is 30 ns for convstb and rdb
----	constant DELTAMIN : time := 3 ns;		-- min pulse time is 30 ns for convstb and rdb
--
--	constant DELTABIG : time := 40 ns;		-- bigger pulse time
--	constant PADT : time := 150 ns;			-- padding time to fit 1 us
--
--	type fir_fsm is ( s0, s00, s1, s2, s3);
--	signal state : fir_fsm;
--	signal count_calc : integer;
--	signal rom_addr, delay_addr : integer;
--
--	signal dur_convstb : integer := 0;
--	signal sched_convstb : integer := -1;
--	signal dur_rdb : integer := 0;
--	signal sched_rdb : integer := -1;
--	
--	signal jiffies : integer := 0;
--	signal previous : integer;
--
--begin
--	Zstate <= 	0 when (state = s0) else
--			1 when (state = s1) else
--			2 when (state = s2) else
--			3 when (state = s3);
--	rom_address <= conv_std_logic_vector( rom_addr, NA);
--	delay_line_address <= conv_std_logic_vector( delay_addr, NA);
--	
--	Zcount_calc <= count_calc;
--
--	p : process( reset, clk, adc_busy, jiffies)
--	begin
--		if (reset = '1') then						-- init everything on reset
--			sched_convstb <= -1;
--			dur_convstb <= 0;
--			sched_rdb <= -1;
--			dur_rdb <= 0;
--
--			buff_oe <= '0';
--			rom_addr <= 0;
--			delay_addr <= 0;
--			accu_ctrl <= '0';
--			delay_line_sample_shift <= '0';
--			count_calc <= 0;
--
--			state <= s0;
--		else
--			case state is
--				when s0 =>
--					if (adc_busy'event and adc_busy = '1') then
--						sched_convstb <= jiffies + 1;
--						dur_convstb <= 1;
----						adc_convstb <= '0' after 0 ns, '1' after DELTAMIN;	-- start first conversion now
--					elsif (adc_busy'event and adc_busy = '0') then
--						state <= s1;			-- conv inited, JUMP TO S1
--					end if;
--				
--				when s00 =>
--					
--				when s1 =>
--					if (adc_busy = '1' and clk'event and clk = '0') then	-- wait for initiated conversion to finish..
--						rom_addr <= 0;
--						delay_addr <= 0;
--						count_calc <= 0;			-- count is the number of loops (ie : samples/coeffs) to calculate next
----						adc_rd_csb <= '0' after 0 ns, '1' after DELTAMIN;	-- time to read the result..
--						delay_line_sample_shift <= '1' after 0 ns, '0' after DELTAMIN;	-- latch up
--						accu_ctrl <= '1';		-- .. and do maths on it
--						state <= s2;			-- JUMP TO S2
--
----						adc_convstb <= '0' after 2*DELTABIG, '1' after 3*DELTABIG;		-- stop asking then
----						adc_convstb <= '0' after 0 ns, '1' after 25 ns;		-- stop asking then (pulse is 20 ns min)
--						sched_convstb <= jiffies + 4;
--						dur_convstb <= 1;
--						sched_rdb <= jiffies + 1;
--						dur_rdb <= 1;
--						
--						accu_ctrl <= '1';		-- .. and do maths on it
--					end if;
--				when s2 =>
--					if (clk'event) then
--						if (count_calc >= (2**NA-1)) then
--							buff_oe <= '1' after 0 ns, '0' after DELTABIG;	-- calculus is over : hand over the result
--							state <= s3;			-- JUMP TO S3
--							count_calc <= 0;
--							accu_ctrl <= '0';
--						else
--							count_calc <= count_calc + 1;		-- calc loop
--							rom_addr <= rom_addr + 1;	-- do the maths..
--							delay_addr <= delay_addr + 1;	--
--						end if;
--					end if;
--				when s3 =>
----					state <= s1 after PADT;
--					state <= s1;			-- FIXE : we should pad-wait to reach 1us per sample
--			end case;
--		end if;
--	end process;
--
--	jiffies_p : process( clk, reset, sched_convstb, dur_convstb, sched_rdb, dur_rdb)
--	begin
--		if (reset = '1') then
--			jiffies <= 0;
--			adc_convstb <= '1';
--			adc_rd_csb <= '1';
--		else
--			if (jiffies = (sched_convstb + dur_convstb)) then
--				adc_convstb <= '1';
--			elsif (jiffies = sched_convstb) then
--				adc_convstb <= '0';
--			end if;
--			if (jiffies = (sched_rdb + dur_rdb)) then
--				adc_rd_csb <= '1';
--			elsif (jiffies = sched_rdb) then
--				adc_rd_csb <= '0';
--			end if;
--			if (clk'event) then
--				jiffies <= jiffies + 1;
--			end if;
--		end if;
--	end process;
--end architecture;

-- good beh : samples+calc*32 every 1 us -- PROBLEM : NOT-SYNTHESISABLE !!!!!!!!!!!!!!!!

architecture beh of fsm is

	type fir_fsm is ( s0, s00, s01, s1, s10, s11, s2, s3, s30);
	signal state : fir_fsm;
	signal count : integer;
	signal rom_addr, delay_addr : integer;
	
	signal jiffies, schedule : integer;
begin
	rom_address <= conv_std_logic_vector( rom_addr, NA);
	delay_line_address <= conv_std_logic_vector( delay_addr, NA);
    
	p : process( reset, clk, adc_busy
				, state, jiffies, schedule
				)
	begin
		if (reset = '1') then						-- init everything on reset
			jiffies <= 0;
			schedule <= 0;
			buff_oe <= '0';
			rom_addr <= 0;
			delay_addr <= 0;
			count <= 0;
			adc_rd_csb <= '1';
			adc_convstb <= '1';
			accu_ctrl <= '0';
			delay_line_sample_shift <= '0';
			state <= s0;
		else
			if (clk'event and clk = '1') then
				jiffies <= jiffies + 1;
			end if;
			
			case state is
				when s0 =>
					if (adc_busy'event and adc_busy = '1') then
						adc_convstb <= '0';		-- start first conversion now
						schedule <= jiffies + 1;
						state <= s00;
					end if;
				
				when s00 =>
					if (jiffies >= schedule) then
						adc_convstb <= '1';		-- start first conversion now
						state <= s01;			-- conv inited, JUMP TO S01
					end if;
				
				when s01 =>
					if (adc_busy'event and adc_busy = '0') then
						state <= s1;			-- result result, JUMP TO S1
					end if;
				
				when s1 =>
						accu_ctrl <= '0';
					adc_rd_csb <= '0';	-- time to read the result..
					rom_addr <= 0;
					delay_addr <= 0;
					count <= 0;			-- count is the number of loops (ie : samples/coeffs) to calculate next
					if (jiffies >= schedule) then
						schedule <= jiffies + 2;
						state <= s10;
					end if;

				when s10 =>
					if (jiffies >= schedule) then
						buff_oe <= '0';		-- calculus is over : hand over the result
						adc_rd_csb <= '1';	-- the result is ready..
						delay_line_sample_shift <= '1';				-- latch up..
						schedule <= jiffies + 1;
						state <= s11;			-- JUMP TO S11
					end if;

				when s11 =>
					if (jiffies >= schedule) then
						delay_line_sample_shift <= '0';				-- latched up
--						accu_ctrl <= '1';					-- .. so we can do maths on it
						schedule <= jiffies + 24;		-- PAD to 1us
						state <= s2;			-- JUMP TO S2
					end if;

				when s2 =>
					if (clk'event and clk = '1') then
--					if (clk'event) then
						accu_ctrl <= '1';					-- .. so we can do maths on it
						if (jiffies = (schedule + 1)) then
							adc_convstb <= '1';
						elsif (jiffies = schedule) then
							adc_convstb <= '0';
						end if;
						if (count >= (2**NA)) then
							count <= 0;
							state <= s3;			-- JUMP TO S3
						else
							count <= count + 1;		-- calc loop
							rom_addr <= rom_addr + 1;	-- do the maths..
							delay_addr <= delay_addr + 1;	--
						end if;
					end if;
					
				when s3 =>
					if (jiffies >= schedule) then
						schedule <= jiffies + 4;		-- pad to 1us per sample
--						schedule <= jiffies + 1;		-- pad to 1us per sample
--						schedule <= jiffies;		-- pad to 1us per sample
						state <= s30;
					end if;
				
				when s30 =>
						buff_oe <= '1';		-- calculus is over : hand over the result
--				when others =>
					if (jiffies >= schedule) then
						schedule <= jiffies;
						state <= s1;
					end if;
			end case;
		end if;
	end process;
end architecture;

-- good beh, samples every 2us
--
--architecture beh_good of fsm is
--	constant DELTAMIN : time := 30 ns;		-- min pulse time is 30 ns for convstb and rdb
----	constant DELTAMIN : time := 3 ns;		-- min pulse time is 30 ns for convstb and rdb
--
--	constant DELTABIG : time := 40 ns;		-- bigger pulse time
--
--	type fir_fsm is ( s0, s1, s2, s3);
--	signal state : fir_fsm;
--	signal count : integer;
--	signal rom_addr, delay_addr : integer;
--begin
--	Zstate <= 	0 when (state = s0) else
--			1 when (state = s1) else
--			2 when (state = s2) else
--			3 when (state = s3);
--	rom_address <= conv_std_logic_vector( rom_addr, NA);
--	delay_line_address <= conv_std_logic_vector( delay_addr, NA);
--	
--	Zcount <= count;
--
--	p : process( reset, clk, adc_busy)
--	begin
--		if (reset = '1') then						-- init everything on reset
--			buff_oe <= '0';
--			rom_addr <= 0;
--			delay_addr <= 0;
--			count <= 0;
--			adc_rd_csb <= '1';
--			adc_convstb <= '1';
--			accu_ctrl <= '0';
--			delay_line_sample_shift <= '0';
--			state <= s0;
--		else
--			case state is
--				when s0 =>
--					if (adc_busy'event and adc_busy = '1') then
--						adc_convstb <= '0' after 0 ns, '1' after DELTAMIN;	-- start first conversion now
--						state <= s1;			-- JUMP TO S1
--					end if;
--				when s1 =>
--					if (adc_busy = '0') then		-- wait for initiated conversion to finish..
--						if (clk'event and clk = '0') then
--							rom_addr <= 0;
--							delay_addr <= 0;
--							count <= 0;			-- count is the number of loops (ie : samples/coeffs) to calculate next
--							adc_convstb <= '1';		-- stop asking then
--							adc_rd_csb <= '0' after 0 ns, '1' after DELTAMIN;	-- time to read the result..
--							delay_line_sample_shift <= '1' after 0 ns, '0' after DELTAMIN;	-- latch up
--							accu_ctrl <= '1';		-- .. and do maths on it
--							state <= s2;			-- JUMP TO S2
--						end if;
--						if (clk'event and clk = '1') then
--							accu_ctrl <= '1';		-- .. and do maths on it
--						end if;
--					end if;
--				when s2 =>
----					adc_rd_csb <= '1';			-- okay, we got the sample
--					if (clk'event and clk = '0') then
--						if (count >= (2**NA-1)) then
--							buff_oe <= '1' after 0 ns, '0' after DELTABIG;	-- calculus is over : hand over the result
----							adc_convstb <= '0' after 0 ns, '1' after DELTAMIN;		-- start next conversion now !
--							state <= s3;			-- JUMP TO S3
--							count <= 0;
--							accu_ctrl <= '0';
--						else
--							count <= count + 1;		-- calc loop
--							rom_addr <= rom_addr + 1;	-- do the maths..
--							delay_addr <= delay_addr + 1;	--
--						end if;
--					end if;
--				when s3 =>
--					adc_convstb <= '0' after 0 ns, '1' after DELTAMIN;	-- start next conversion now
--					state <= s1;
--			end case;
--		end if;
--	end process;
--end architecture;




