library ieee;
use ieee.std_logic_1164.all;		-- std_logic_vector
use ieee.std_logic_arith.all;		-- conv_std_logic
use ieee.std_logic_unsigned.all;	-- ditto

entity tb_accu is
end entity;

architecture beh of tb_accu is
	constant CLKTIME : time := 4 ns;
	
	constant NDI : integer := 16;
	constant NDO : integer := 21;

component accu is
	generic(	NDI : integer := NDI;
			NDO : integer := NDO
		);
	port(	accu_in : in std_logic_vector( (NDI - 1) downto 0);
		accu_ctrl : in bit;
		clk : in bit;
		reset : in bit;
		accu_out : out std_logic_vector( (NDO - 1) downto 0));
end component;

	signal clk, ctrl, reset : bit;
	signal accu_in : std_logic_vector( (NDI - 1) downto 0);
	signal accu_out : std_logic_vector( (NDO - 1) downto 0);

begin
	a1 : accu
		port map( accu_in, ctrl, clk, reset, accu_out);
	
	reset <= '1' after 0 ns, '0' after 3 ns, '1' after 44 ns, '0' after 56 ns;
	ctrl <= '0' after 0 ns, '1' after 7 ns, '0' after 23 ns, '1' after 71 ns;
	accu_in <= conv_std_logic_vector( 12, NDI);
	c : process
	begin
		clk <= not clk;
		wait for CLKTIME;
	end process;
end architecture;



