library ieee;
use ieee.std_logic_1164.all;		-- std_logic_vector
use ieee.std_logic_arith.all;		-- conv_std_logic
use ieee.std_logic_unsigned.all;	-- ditto

entity tb_buff is
end entity;

architecture beh of tb_buff is
	constant CLKTIME : time := 4 ns;
	
	constant ND : integer := 8;

component buff is
	generic(	ND : integer := ND	-- data width
		);

	port(	buff_in : in std_logic_vector( (ND - 1) downto 0);
		buff_oe : in bit;
		clk : in bit;
		reset : in bit;
		buff_out : out std_logic_vector( (ND - 1) downto 0));
end component;

	signal clk, oe, reset : bit;
	signal buff_in : std_logic_vector( (ND - 1) downto 0);
	signal buff_out : std_logic_vector( (ND - 1) downto 0);
	signal wa : integer;

begin
	b1 : buff
		port map( buff_in, oe, clk, reset, buff_out);
	
	wa <= 0 after 0 ns, 12 after 7 ns, 38 after 19 ns, 63 after 56 ns;
	reset <= '1' after 0 ns, '0' after 3 ns, '1' after 22 ns, '0' after 25 ns, '1' after 71 ns, '0' after 84 ns;
	oe <= '0' after 0 ns, '1' after 5 ns, '0' after 9 ns, '1' after 34 ns, '0' after 49 ns;
	buff_in <= conv_std_logic_vector( wa, 8);
	c : process
	begin
		clk <= not clk;
		wait for CLKTIME;
	end process;
end architecture;









